from math import *
from splitstring import *
from calc_p_from_t import *
from calc_t_from_p import *
import matplotlib
import matplotlib.pyplot as plt

def CheckStr(str):
    ck = False
    if len(str) > 0:
        if str[0] == '/':
            ck = True
    return ck

#
#       Prepare the input data file
#
s_in = input("Input data file = ")
f_in = open(s_in, "r")
#
#       Set the contents of the input data file in the object data 
#
data_f = f_in.readlines()
f_in.close()

#
#       Prepare the output file
#
s_out = input("Output data file = ")
f_out = open(s_out, "w")
f_out.write("Input data file = " + s_in + "\n\n")

pos = 0
while not CheckStr(data_f[pos]):
    print(data_f[pos])
    pos += 1

pos += 1

splitStr = CSplit(' ', '\t')
splitStr.set_string(data_f[pos])
YLabel = splitStr.seek_nonempty(0)
XLabel = splitStr.seek_nonempty(1)

Y = []
X = []
n = 0
pos += 1
while not CheckStr(data_f[pos]):
    splitStr.set_string(data_f[pos])
    Y.append(float(splitStr.seek_nonempty(0)))
    X.append(float(splitStr.seek_nonempty(1)))
    n += 1
    pos += 1

f_out.write(" ")
f_out.write("Input data...\n")
sumX = 0.0
sumY = 0.0
for i in range(n):
    f_out.write("{0:10}{1:10}\n".format(Y[i], X[i]))
    sumX += X[i]
    sumY += Y[i]

meanX = sumX / n
meanY = sumY / n

SSX = 0.0
SSY = 0.0
SXY = 0.0
for i in range(n):
    SSX += (X[i] - meanX) ** 2.0
    SSY += (Y[i] - meanY) ** 2.0
    SXY += (X[i] - meanX) * (Y[i] - meanY)

b1 = SXY / SSX
b0 = meanY - b1 * meanX
f_out.write("\nb0 = {}\n".format(b0))
f_out.write("b1 = {}\n".format(b1))
f_out.write("{0} = {1:.7} + {2:.7} * {3}\n".format(YLabel, b0, b1, XLabel))

r  = SXY / (sqrt(SSX) * sqrt(SSY))
R2 = r ** 2.0

f_out.write("\nCoefficient of determination: R2 = {0:.7}\n".format(R2))
f_out.write("Correlation coefficient:       r = {0:.7}\n".format(r))

SSE = 0.0
for i in range(n):
    SSE += (Y[i] - (b0 + b1 * X[i])) ** 2.0

MSE = SSE / (n - 2.0)
s2b1 = MSE / SSX
sb1 = sqrt(s2b1)
t = b1 / sb1

calc_p = C_cum_t(n - 2)
p = calc_p.v(t)
if p < 0.5:
    p = 2 * p
else:
    p = 2 * (1.0 - p)

f_out.write("\nt = {0:.7}   p-value = {1:.7f}   df = {2}\n".\
            format(t, p, n - 2))

calc_t = CCalc_t(n - 2) 
t_a2 = calc_t.v(1.0 - 0.025)
L_Int = b1 - sb1 * t_a2
U_Int = b1 + sb1 * t_a2
f_out.write("\n95% Confidence Interval = [{0:.7}, {1:.7}]\n".format(L_Int, U_Int))

f_out.close()

min_x = X[0]
max_x = X[0]
for i in range(n):
    if min_x > X[i]:
        min_x = X[i]
    if max_x < X[i]:
        max_x = X[i]

L_y = b0 + b1 * min_x
R_y = b0 + b1 * max_x

plt.xlabel(XLabel)
plt.ylabel(YLabel)
plt.title("{0} = {1:.7} + {2:.7} * {3}".format(YLabel, b0, b1, XLabel) +\
          "R2 = {0:.5}        r = {1:.5}".format(R2, r))
plt.plot(X, Y, 'go')
plt.plot([min_x, max_x], [L_y, R_y])
plt.show()

